--VERSION 0.0.10
--DATE 10 08 2014

--RECENT CHANGES
-- added beginnings of an options frame to /rlr options (still not saving data though)

--TO DO
-- finish Options frame
--include checking roll type in ProcessRoll and add it to reply string

local RLRMLFrame = CreateFrame("Frame") -- creating  the addon frame
RLRMLFrame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
RLRMLFrame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
RLRMLFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED"); -- Fired when about to log out
RLRMLFrame:RegisterEvent("CHAT_MSG_ADDON"); -- Fired when about to log out
RLRMLFrame:RegisterEvent("OPEN_MASTER_LOOT_LIST") -- Fired when starting master looter
RLRMLFrame:SetScript("OnEvent",RLRMLFrame.OnEvent) --probably sets script so that when an event fires, the function below is ran?
RLRMLFrame:SetScript("OnEvent",RLRMLFrame.OnEvent)
function RLRMLFrame:OnEvent(event,arg1,arg2,arg3,arg4) -- function pertaining to the frame that checks addon being loaded (probably very wrong to do it like this)-- FORMER (WORKING) VERSION, REVERT IF NEW ONE DOESN´T WORK
 	--if event == "PARTY_LOOT_METHOD_CHANGED" then --REMOVING THESE FROM RLRML AND LEAVING THEM IN RLR ONLY
	--RLRMLFunctions.CheckLootMethod()
	--elseif event == "CHAT_MSG_ADDON" and arg1 ~= "RLRRoll" then  --DEBUG
	--	print("event= ",event,",arg1= ",arg1,",arg2=",arg2,",arg3=",arg3,",arg4=",arg4) --DEBUG
	if event == "ADDON_LOADED" and arg1 == "RankedLootRollML" then --checking that the addon being loaded is this one
			RLRMLFunctions.Initialize()
			if RLRMLFirstRun == nil then
				RLRMLFunctions.FirstRun()
			end
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRRoll" then
			print(addon,arg1)
			RLRMLFunctions.ProcessRoll(arg1,arg2,arg3,arg4)
			 --end of if block (if event == "ADDON_LOADED" and arg1 == "RankedLootRollML")
	elseif event == "OPEN_MASTER_LOOT_LIST" then
		RLRMLFunctions.LootInfo()
	end --end of if block checking RLRMLSavedData
	end
 --end of function RLRMLFrame


 
-- MAIN TABLES GET DEFINED BELOW HERE
RLRMLFunctions = {} -- making a table for storing functions
RLRMLFunctionsSave=RLRMLFunctions
local RLRMLFunctions = RLRMLFunctions -- because of the tip that local functions are accessed faster (I still don´t understand why exactly this works though)
RLRMLFunctionsSave=RLRMLFunctions
RLRMLGuildRanks={}
RLRMLChannels = {} -- for keeping tabs on channels joined
RLRMLSessionLooted = {} -- for stuff I don´t need to save, but want to access between RLR and RLRML
RLRMLGuildRanks={}
--DEFAULT VALUES GO HERE...
--RLRMLDefaults ={}
-- RLRMLDefaults.CoreRaiderMin=180
-- RLRMLDefaults.RaiderMin=100
-- RLRMLDefaults.TrialMin=1
-- RLRMLDefaults.GearingUpMin=1
-- RLRMLDefaults.AltMin=0
-- RLRMLDefaults.CoreRaiderMax=280
-- RLRMLDefaults.RaiderMax=200
-- RLRMLDefaults.TrialMax=100
-- RLRMLDefaults.GearingUpMax=100
-- RLRMLDefaults.AltMax=1
-- RLRMLDefaults.MinorUpgrade=-10
-- RLRMLDefaults.NormalUpgrade=0
-- RLRMLDefaults.BestInSlot=10
-- RLRMLDefaults.Offspec=-50
-- RLRMLDefaults.OutsideofGuildMin=0
-- RLRMLDefaults.OutsideofGuildMax=1

--RLRMLDefaults.GuildRank= --TODO LOAD GUILD RANK NAMES 
--DEFAULT VALUES

-- FUNCTIONS GET DEFINED BELOW HERE

-- FUNCTIONS THAT ARE NOT CALLED BY SLASH COMMANDS
 
	-- FUNCTIONS RELATED TO THE CHANNEL NAME
	
function RLRMLFunctions.Test()
local lootIcon="Interface\\Icons\\INV_Misc_Coin_06"
--lootIcon=
local itemlink="|cff9d9d9d|Hitem:7073:0:0:0:0:0:0:0:80:0:0|h[Broken Fang]|h|r"
local index=1
print("RLRML DEBUG: 91 - lootIcon=",lootIcon)
local LootMessage=strjoin(".",index,lootIcon,itemlink)
print("Debug:RLRMLFunctions.Test 93 :printing LootMessage-",LootMessage)
if UnitInParty("Player") == nil then 
	SendAddonMessage("RLRItemLink",LootMessage,"WHISPER",UnitName("Player")) -- MAINLY FOR TESTING PURPOSES, NORMALLY THIS WOULD NEVER BE CALLED WHILE PLAYING SOLO
	print ("DEBUG: RLRML Test 94 - sent whisper to self")
	else
	SendAddonMessage("RLRItemLink",LootMessage,"RAID")
	end
end

function RLRMLFunctions.Initialize()
	print ("RLRML main lua file v 0.0.1 loaded properly")
	RegisterAddonMessagePrefix("RLRRoll")
	RegisterAddonMessagePrefix("RLR")
	RegisterAddonMessagePrefix("RLRReply")
	RegisterAddonMessagePrefix("RLRItemLink")
	local PlayerName = UnitName("Player")
	local sname, srealm = strsplit("-",PlayerName)
	local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
--	if unpack(RLRMLGuildRanks)== nil then RLRMLFunctions.GuildRankRollDefaults()
--	end
	--if sguildName ~= RLRMLDefaults.GuildName then
	--print ("Guild name different from default guild name - ")
	--end
 end
	
function Strip(cname) 
  return string.gsub(cname, "%W", "")
end

CheckSum = function(text)
	local counter = 1
	local len = string.len(text)
	for i=1,len do
		counter = counter + string.byte(text, i)*math.pow(31, len- i)
	end
	counter = math.fmod(counter, 7919)
	return string.format("%06x", counter)
end

function RLRMLConcatRealmName(name,realm)
	if realm then name=strjoin ("-",name,realm)
	end
	print ("RLRML DEBUG:returning name for ConcatRealmName")
	return name
end

-- END OF FUNCTIONS RELATED TO CHANNEL NAME

-- TABLECOPY (USING IT FOR LOADING DEFAULT VALUES ON INITIAL LOAD, WORKS SO LONG AS BOTH TABLES EXIST BEFORE IT IS INVOKED)

	
function RLRMLFunctions.tablecopy(sourcetable, targettable)
for k,v in pairs(sourcetable) do
 targettable[k] = v
end
return targettable
end

function RLRMLFunctions.GuildRankRollDefaults()
local i=1
--NEED TO IMPLEMENT A NO-GUILD SANITY CHECK
wipe (RLRMLGuildRanks)
	for i=1,10 do
	if i==0 then i=1 end
	local GuildRankName=GuildControlGetRankName(i)
	print("Rank ",i," - ",GuildRankName)
	GuildRankName=strjoin("-",i,GuildRankName)
	tinsert(RLRMLGuildRanks,GuildRankName)
	RLRMLGuildRanks[GuildRankName]={}
	local rollmin=500-(i*50)
	local rollmax=1000-(i*90)
	--tinsert(RLRMLGuildRanks[GuildRankName],"roll range min")
	tinsert(RLRMLGuildRanks[GuildRankName],rollmin)
	--tinsert(RLRMLGuildRanks[GuildRankName],"roll range max")
	tinsert(RLRMLGuildRanks[GuildRankName],rollmax)
	end
	return RLRMLGuildRanks
--else
--print ("not in a guild, this will likely bug out")
end


function RLRMLFunctions.FirstRun() -- LOADING DEFAULT VALUES, SETTING GUILD RANKS ETC. - SHOULD IT BE SAVED PER CHARACTER?
print ("You are running RLRML for the first time or the settings file is corrupted, loading default values")
	--RLRMLRollValues={}
	RLRMLFunctions.GuildRankRollDefaults()
	--RLRMLFunctions.tablecopy (RLRMLDefaults,RLRMLRollValues)
	--print("Copying DefaultValues into RollValues")
	--IMPLEMENT LOADING OF DEFAULTS INTO ROLLVALUES
	local PlayerName = UnitName("Player")
	local sname, srealm = strsplit("-",PlayerName)
	local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
	print ("sender= ",sname,"sguildName = ",sguildName,"sguildRankName= ",sguildRankName,", sguildRankIndex= ",sguildRankIndex) --DEBUG
	--RLRMLDefaults.Guildname=(sguildName)
	--print("Setting ",sguildName," as default guild")
	RLRMLFirstRun=1;
 end
 
 function RLRMLFunctions.CheckLootMethod() 
 -- TODO IN FUTURE - WHEN LOOT METHOD CHANGES, ASK WHETHER TO TURN ADDON ON. IF SO, SET SESSION VARIABLE WHICH OTHER EVENT CHECKS IN HANDLER WOULD CHECK BEFORE FIRING 
	local lootmethod=GetLootMethod()
			if not IsInGroup(Player) then --IF NOT IN GROUP, do nothing
			print ("not in group")
			end
			if lootmethod=="master" then --IF IN GROUP, JOIN THE RLR/RLRML COMM CHANNEL
			print("Joining RLR/RLRML communication channel") --DEBUG
			RLRMLFunctions.Channel()
			end
end 

 
-- SLASH COMMAND FUNCTIONS
function RLRMLFunctions.OptionsPanel(...) -- RLR Master Looter Options panel
   print('DEBUG:loading RLRML options');
	print("Showing options")
	OptionsFrame:Show()
end

function RLRMLFunctions.SavedData(...) -- RLR printing the contents of the table "RLRMLFunctions"
  print ("printing the contents of the table RLRMLSavedData");
  table.foreach(RLRMLSavedData, print) -- Prints the whole table, going to remove this soon
 print ("");
 print ("Now printing the last entry once more, for good measure");
  local RLRTableLength = table.getn(RLRMLSavedData); -- find the size of the table 
  print(RLRMLSavedData,RLRTableLength); -- prints the last entry from the table, but it needs to be converted to string first
  end
   
 function RLRMLFunctions.GetMLName()
 local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	
	if UnitInParty("Player") == nil then
	print ("DEBUG:Not in a party, sending RLRML comm to self")
	RLRMLName=UnitName("Player")
	
	elseif masterlooterRaidID ~= nil then --I´m in a raid, everything seems to work as intended
	RLRMLName = GetRaidRosterInfo(masterlooterRaidID)
	print("DEBUG:masterlooterRaidID=",masterlooterRaidID)
	print ("DEBUG:Sending RLRML messages to: ",RLRMLName)

	elseif masterlooterRaidID == nil and masterlooterPartyID == 0 and lootmethod == "master" then -- I´m not in a raid and ML is probably myself
	RLRMLName = GetUnitName("Player")
	print("DEBUG:master looter is probably myself?")
	print (RLRMLName)
	
	elseif masterlooterRaidID == nil and masterlooterPartyID ~= 0 and lootmethod == "master" then -- I´m not in a raid, I AM in a party with the masterlooter and ML is probably not myself?
	local temp = strjoin ("","Party",masterlooterPartyID)
	name, realm = UnitName(temp, true)
	RLRMLConcatRealmName(name,realm) -- still not showing realm name though
	print ("DEBUG:Sending RLRML messages to:",name)
	
	elseif lootmethod ~= "master" then
	print ("not using master looter,sending RLRML comm to self")
	RLRMLName=UnitName("Player")
	end
	
	print (RLRMLName,"=RLRMLName")
	return (RLRMLName)
	end
   
function RLRMLFunctions.Channel() -- Takes care of creating/joining channel for communication between RLRML and RLR
	RLRMLName=RLRMLFunctions.GetMLName()
	if RLRMLName then
	local cname=RLRMLName	
	local cs = CheckSum(cname) -- cleaning the loot master name and adding checksum to create unique channel name
	local cname = Strip(cname)
	local cname = string.sub(cname, 1, 8)
	GroupChannelName = ("RLR" .. cname .. cs)
	print ("RLR and RLRML communication channel is called", GroupChannelName)
	SendAddonMessage("RLR",GroupChannelName, "RAID" );
	--SendChatMessage(GroupChannelName, "GUILD", nil) --debug, just checking if it works, remove later
	print("Group channel name=",GroupChannelName)
	print("whisper target name=",RLRMLName)
	-- now join the channel if I´m not already in it
	if GetChannelName(GroupChannelName) == 0 then
		for index,value in ipairs(RLRMLChannels) do 
		LeaveChannelByName(value)
		print ("Leaving",value)
		end
	wipe(RLRMLChannels)
	print ("joining channel ",GroupChannelName)
	JoinChannelByName(GroupChannelName)
	tinsert(RLRMLChannels, GroupChannelName)
	else -- else tell me I´m already in
		print ("already in the channel")
		tinsert(RLRMLChannels, GroupChannelName)
	end
	end
end

--function RLRMLFunctions.temp(table,value) --TEMP FUNCTION TEMPORARY DEBUG ETC...
--	RLRMLFunctions.TableSearch(RLRMLGuildRanks,value)
--end

-- function RLRMLFunctions.TableSearch(table, item) -- WORKS BUT MIGHT NOT BE NECESSARY... GUILD RANK ROLLVALUES IS ALREADY NICELY SORTED BY RANK ID - ANYWAY, 
  -- for index,value in ipairs(table) do 
  -- DEFAULT_CHAT_FRAME:AddMessage(tostring(index).." : "..value)
  -- if value==item 
  -- then print ("value ",value,"=","item ",item)
  -- --RLRMLFunctions.TableSearchInside(item)
  -- local foundit=1
  -- end
  -- if not foundit==1 then print ("value ",value," not found in table",table)
  -- end
-- end
-- end 

function RLRMLFunctions.DebugDdump(o) --PRINTS FULL CONTENT OF A TABLE
    if type(o) == 'table' then
        local s = '{ '
        for k,v in pairs(o) do
                if type(k) ~= 'number' then k = '"'..k..'"' end
                s = s .. '['..k..'] = ' .. dump(v) .. ','
        end
        return s .. '} '
    else
		print (o)
        return tostring(o)
		end
end

function RLRMLFunctions.LootInfo()
		print ("still working at line 295")
		for index = 1, GetNumLootItems() do
			local lootIcon, lootName, lootQuantity, rarity, locked  = GetLootSlotInfo(index);
			if rarity>1 then
				local itemlink = GetLootSlotLink(index);
				tinsert (RLRMLSessionLooted,lootName)
				local LootMessage=strjoin("/",index,lootIcon,itemlink)
				print("Debug:LootInfo:printing LootMessage-",LootMessage)
				SendAddonMessage("RLRItemLink",LootMessage,"RAID");
				local tempstring=strjoin ("","This is up for grabs:",itemlink)
				SendChatMessage(itemlink,"PARTY");
				--print ("RLRML Debug: Item up for grabs:",tempstring)
			else
			--	print ("DEBUG:Ignoring ",lootname, " low rarity - ", rarity)
			end
		end
 end

 if UnitInParty("Player") == nil then 
	SendAddonMessage("RLRItemLink",LootMessage,"WHISPER",UnitName("Player")) -- MAINLY FOR TESTING PURPOSES, NORMALLY THIS WOULD NEVER BE CALLED WHILE PLAYING SOLO
	print ("DEBUG: RLRML Test 94 - sent whisper to self")
	else
	SendAddonMessage("RLRItemLink",LootMessage,"RAID")
	end
 
 
 
 
 
 

function RLRMLFunctions.RollType(message)
if message=="Major" then  modifier =0
elseif message=="Minor" then  modifier =-50
elseif message=="Offspec" then  modifier =-200
elseif message=="BIS" then  modifier =10
print (modifier)
end		
return modifier
end


--RLRMLFunctions.ProcessRoll-- HANDLES THE RECEIVED MESSAGES - CHECKS GUILD STATUS (GUILD, RANK) OF SENDER, TYPE OF ROLL AND FORMS A RANDOM ROLL IN THE APPROPRIATE RANGE
 function RLRMLFunctions.ProcessRoll(prefix,message,distributiontype,sender)
	 local sname, srealm = strsplit("-",sender)
	 print (sname,"  ",srealm)
	 local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
	 local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
	
	 if sguildName==pguildName and pguildName ~= nil then do--DISABLED FOR TESTING/DEBUGGING, BECAUSE I DON´T HAVE A SECOND CHAR TO TEST WITH IN GUILD (STARTER EDITIONS CAN´T JOIN GUILDS)
		 local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
		 local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
		 local modifier=RLRMLFunctions.RollType(message)
		 print(modifier)
		 local sguildRankIndex1=sguildRankIndex+1
		 local GuildRankName=strjoin("-",sguildRankIndex1,sguildRankName)
		 print ("GuildRankName=",GuildRankName)
		 local rollmin, rollmax = unpack(RLRMLGuildRanks[GuildRankName])
		 rollmin=rollmin+modifier
		 rollmax=rollmax+modifier
		 print ("rollmin= ",rollmin)
		 print ("rollmax= ",rollmax)
		 local roll=math.random(rollmin,rollmax)
		 print ("|cFF00FF00",sender, "|r rolls |cFF00FF00",roll, "|r on |cFF0000FF XY |r in the range ",rollmin,", ",rollmax)
		 local Reply=strjoin("","You roll |cFF00FF00", roll,"|r on |cFF0000FF XY |r in the range ",rollmin,", ",rollmax)
		 SendAddonMessage("RLRReply",Reply, "WHISPER",sender) -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNT
		 end
		
	 else
		 SendAddonMessage("RLRReply","You cannot roll if you are not in the guild", "WHISPER",sender) -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNTend
	 end
	 --SendAddonMessage("RLRReply",Reply, "WHISPER",sender) -- TEMPORARILY DISABLED TO SEE IF THE REASON IT WAS NOT FIRING COULD BE THAT I AM TESTING WITH A STARTER EDITION CHAR
 end
 
 
 
 
 
 
-- function RLRMLFunctions.GuildStatusCheck(sender)
-- local sender = UnitName("Player") -- FOR DEBUG, DISABLE LATER TO CHECK SENDER OF RLR ROLL MESSAGE
-- local sname, srealm = strsplit("-",sender)
-- local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
-- print ("sender= ",sname,"sguildName = ",sguildName,"sguildRankName= ",sguildRankName,", sguildRankIndex= ",sguildRankIndex) --DEBUG
 -- end
 
-- function RLRMLFunctions.Sendmsg(prefix, msg) --syncing function borrowed from DBM
--	local msg = msg or "MessageContent"
--	if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and IsInInstance() then--For BGs, LFR and LFG (we also check IsInInstance() so if you're in queue but fighting something outside like a world boss, it'll sync in "RAID" instead)
--		SendAddonMessage("RLR",msg, "INSTANCE_CHAT")
--	else
--		if IsInRaid() then
--			SendAddonMessage("RLR",msg, "RAID")
--		elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
--			SendAddonMessage("RLR",msg, "PARTY")
--		else--for solo raid
--			SendAddonMessage("RLR",msg, "WHISPER", playerName)
--		end
--	end
--end editbox


 -- FUNCTIONS ARE DEFINED ABOVE HERE
	
	
-- ++ 

--WORK IN PROGRESS - SLASH COMMAND
SLASH_RLRML1, SLASH_RLRML2 = '/RLRML', '/rlrml'; 
function SlashCmdList.RLRML(msgfull, editbox)--, editbox)
local msg,par1,par2,par3=strsplit(" ",msgfull)
local msg=strlower(msg)
if msg == 'options' then
RLRMLFunctions.OptionsPanel();
elseif msg == 'test' then
RLRMLFunctions.Test();
 elseif msg == 'history' then
RLRMLFunctions.History();
 elseif msg == 'major' then
RLRMLFunctions.Major();
elseif msg == 'saveddata' then
RLRMLFunctions.SavedData();
elseif msg == 'channel' then --debug only
RLRMLFunctions.Channel(); 
elseif msg == 'temp' then --debug only
RLRMLFunctions.temp(); 
elseif msg == 'tablecopy' then --debug only
tablecopy(par1,par2); 
elseif msg == 'guildstatuscheck' then --debug only
RLRMLFunctions.GuildStatusCheck()
elseif msg == 'guildinfo' then --debug only
RLRMLFunctions.GuildRankRollDefaults()
elseif msg == "tableinsert" then 
tinsert(par1,par2,par3)
else
 print("Raid Loot Roll has the following arguments");
 print("/RLRML options for options panel");
 print("/RLRML history for records history");
 print("/RLRML major to perform a major upgrade roll");
 print("/RLRML tableinsert [modifier] to test inserting stuff into table RLRMLSavedData");
 print("/RLRML saveddata to test inserting stuff into table RLRMLSavedData");
 print("/RLRML channel to test the function for creating a unique channel name for cross addon communication and joining it");
 print("/RLRML master to test checking for master looter name");
 print("/RLRML guildstatuscheck to check guild/rank check function")
 print("/RLRML guildinfo to check guild rank / guild rank name check function")
 print("/RLRML temp to run temp function (whatever I´m working on atm)")
 
  end
end
--WORK IN PROGRESS - SLASH COMMAND



RLRMLFrame:SetScript("OnEvent", RLRMLFrame.OnEvent); -- this is not doing what I want it to do (which is to register the slash command) but if I take it away, the message at line 10 doesn´t fire
 function SlashCmdList.rlr(msg, modifier)
 print("registering slash command /rlr ");
 SLASH_RLR = "/rlr";
 message("registering slash command /rlr ");
 end
